madwifi: add support for the ahdemo (ad-hoc demo) mode in /etc/config/wireless. using...
[openwrt/openwrt.git] / package / madwifi / files / lib / wifi / madwifi.sh
1 #!/bin/sh
2 append DRIVERS "atheros"
3
4 scan_atheros() {
5 local device="$1"
6 local wds
7 local adhoc sta ap
8
9 config_get vifs "$device" vifs
10 for vif in $vifs; do
11
12 config_get ifname "$vif" ifname
13 config_set "$vif" ifname "${ifname:-ath}"
14
15 config_get mode "$vif" mode
16 case "$mode" in
17 adhoc|ahdemo|sta|ap)
18 append $mode "$vif"
19 ;;
20 wds)
21 config_get addr "$vif" bssid
22 config_get ssid "$vif" ssid
23 [ -z "$addr" -a -n "$ssid" ] && {
24 config_set "$vif" wds 1
25 config_set "$vif" mode sta
26 mode="sta"
27 addr="$ssid"
28 }
29 ${addr:+append $mode "$vif"}
30 ;;
31 *) echo "$device($vif): Invalid mode, ignored."; continue;;
32 esac
33 done
34
35 case "${adhoc:+1}:${sta:+1}:${ap+1}" in
36 # valid mode combinations
37 1::) wds="";;
38 :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
39 :1:);;
40 ::1);;
41 ::);;
42 *) echo "$device: Invalid mode combination in config"; return 1;;
43 esac
44
45 config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }"
46 }
47
48
49 disable_atheros() (
50 local device="$1"
51
52 # kill all running hostapd and wpa_supplicant processes that
53 # are running on atheros vifs
54 for pid in `pidof hostapd wpa_supplicant`; do
55 grep ath /proc/$pid/cmdline >/dev/null && \
56 kill $pid
57 done
58
59 include /lib/network
60 cd /proc/sys/net
61 for dev in *; do
62 grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
63 ifconfig "$dev" down
64 unbridge "$dev"
65 wlanconfig "$dev" destroy
66 }
67 done
68 return 0
69 )
70
71 enable_atheros() {
72 config_get channel "$device" channel
73 config_get vifs "$device" vifs
74
75 disable_atheros "$device"
76 local first=1
77 for vif in $vifs; do
78 nosbeacon=
79 config_get ifname "$vif" ifname
80 config_get enc "$vif" encryption
81 config_get mode "$vif" mode
82
83 [ "$mode" = sta ] && config_get nosbeacon "$device" nosbeacon
84
85 config_get ifname "$vif" ifname
86 ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
87 [ $? -ne 0 ] && {
88 echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
89 continue
90 }
91 config_set "$vif" ifname "$ifname"
92
93 [ "$first" = 1 ] && {
94 # only need to change freq band and channel on the first vif
95 config_get agmode "$device" mode
96 pureg=0
97 case "$agmode" in
98 *b) agmode=11b;;
99 *bg) agmode=11g;;
100 *g) agmode=11g; pureg=1;;
101 *a) agmode=11a;;
102 *) agmode=auto;;
103 esac
104 iwconfig "$ifname" channel 0 >/dev/null 2>/dev/null
105 ifconfig "$ifname" up
106 iwpriv "$ifname" mode "$agmode"
107 iwpriv "$ifname" pureg "$pureg"
108 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
109 }
110
111 config_get_bool hidden "$vif" hidden
112 iwpriv "$ifname" hide_ssid "$hidden"
113
114 config_get wds "$vif" wds
115 case "$wds" in
116 1|on|enabled) wds=1;;
117 *) wds=0;;
118 esac
119 iwpriv "$ifname" wds "$wds"
120
121 wpa=
122 case "$enc" in
123 WEP|wep)
124 for idx in 1 2 3 4; do
125 config_get key "$vif" "key${idx}"
126 iwconfig "$ifname" enc "[$idx]" "${key:-off}"
127 done
128 config_get key "$vif" key
129 key="${key:-1}"
130 case "$key" in
131 [1234]) iwconfig "$ifname" enc "[$key]";;
132 *) iwconfig "$ifname" enc "$key";;
133 esac
134 ;;
135 PSK|psk|PSK2|psk2)
136 config_get key "$vif" key
137 ;;
138 esac
139
140 case "$mode" in
141 wds)
142 config_get addr "$vif" bssid
143 iwpriv "$ifname" wds_add "$addr"
144 ;;
145 adhoc|ahdemo)
146 config_get addr "$vif" bssid
147 [ -z "$addr" ] || {
148 iwconfig "$ifname" ap "$addr"
149 }
150 ;;
151 esac
152 config_get ssid "$vif" ssid
153
154 [ "$mode" = "sta" ] && {
155 config_get_bool bgscan "$vif" bgscan 1
156 iwpriv "$ifname" bgscan "$bgscan"
157 }
158
159 config_get_bool antdiv "$device" diversity 1
160 sysctl -w dev."$device".diversity="$antdiv" >&-
161
162 config_get antrx "$device" rxantenna
163 if [ -n "$antrx" ]; then
164 sysctl -w dev."$device".rxantenna="$antrx" >&-
165 fi
166
167 config_get anttx "$device" txantenna
168 if [ -n "$anttx" ]; then
169 sysctl -w dev."$device".txantenna="$anttx" >&-
170 fi
171
172 config_get distance "$device" distance
173 if [ -n "$distance" ]; then
174 athctrl -i "$device" -d "$distance" >&-
175 fi
176
177 config_get txpwr "$vif" txpower
178 if [ -n "$txpwr" ]; then
179 iwconfig "$ifname" txpower "${txpwr%%.*}"
180 fi
181
182 ifconfig "$ifname" up
183 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
184
185 local net_cfg bridge
186 net_cfg="$(find_net_config "$vif")"
187 [ -z "$net_cfg" ] || {
188 bridge="$(bridge_interface "$net_cfg")"
189 config_set "$vif" bridge "$bridge"
190 start_net "$ifname" "$net_cfg"
191 }
192 iwconfig "$ifname" essid "$ssid"
193 case "$mode" in
194 ap)
195 config_get_bool isolate "$vif" isolate 0
196 iwpriv "$ifname" ap_bridge "$((isolate^1))"
197
198 if eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
199 hostapd_setup_vif "$vif" madwifi || {
200 echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
201 # make sure this wifi interface won't accidentally stay open without encryption
202 ifconfig "$ifname" down
203 wlanconfig "$ifname" destroy
204 continue
205 }
206 fi
207 ;;
208 wds|sta)
209 case "$enc" in
210 PSK|psk|PSK2|psk2)
211 case "$enc" in
212 PSK|psk)
213 proto='proto=WPA';;
214 PSK2|psk2)
215 proto='proto=RSN';;
216 esac
217 cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
218 ctrl_interface=/var/run/wpa_supplicant
219 network={
220 scan_ssid=1
221 ssid="$ssid"
222 key_mgmt=WPA-PSK
223 $proto
224 psk="$key"
225 }
226 EOF
227 ;;
228 WPA|wpa|WPA2|wpa2)
229 #add wpa_supplicant calls here
230 ;;
231 esac
232 [ -z "$proto" ] || wpa_supplicant ${bridge:+ -b $bridge} -Bw -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
233 ;;
234 esac
235 first=0
236 done
237 }
238
239
240 detect_atheros() {
241 cd /proc/sys/dev
242 [ -d ath ] || return
243 for dev in $(ls -d wifi* 2>&-); do
244 config_get type "$dev" type
245 [ "$type" = atheros ] && return
246 cat <<EOF
247 config wifi-device $dev
248 option type atheros
249 option channel 5
250 # option diversity 1
251 # option txantenna 0
252 # option rxantenna 0
253 # option distance 2000
254 # disable radio to prevent an open ap after reflashing:
255 option disabled 1
256
257
258 config wifi-iface
259 option device $dev
260 option network lan
261 option mode ap
262 option ssid OpenWrt
263 option hidden 0
264 # option txpower 15
265 # option bgscan enable
266 option encryption none
267
268 EOF
269 done
270 }